//+------------------------------------------------------------------+
//|                                            StepStopExpert_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com"
#property link      "http://www.forex-tsd.com/"

//---- input parameters
extern double     InitialStop     = 1500; // 2000 DAX, Forex 30
extern double     BreakEven       = 4000; // 5000 DAX, Forex 20 Profit Lock in pips  
extern double     StepSize        = 500;  //  500 DAX, Forex 5 
extern double     MinDistance     = 100;  //  100 DAX, Forex 10
extern int        ATR_period      =14;    // 24
extern int        ATR_multiplier  =3;

int   k,digit=0;
bool BE=false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {

//----
   return(0);
  }
// ---- Stepped Stops
void StepStops()
  {

// Getting the ATR values
   double ATR=iATR(NULL,0,ATR_period,0);
   ATR*=ATR_multiplier;

   double BuyStop,SellStop,ATR_TakeProfit;
   int total=OrdersTotal();
   for(int cnt=0;cnt<total;cnt++)
     {
      if(OrderSelect(cnt,SELECT_BY_POS)==true)
        {
         int mode=OrderType();
         if(OrderSymbol()==Symbol())
           {
            if(mode==OP_BUY)
              {
               BuyStop=OrderStopLoss();
               if(Bid-OrderOpenPrice()>0 || OrderStopLoss()==0)
                 {
                  if(Bid-OrderOpenPrice()>=Point*BreakEven && !BE) {BuyStop=OrderOpenPrice();BE=true;}

                  if(OrderStopLoss()==0) {BuyStop=OrderOpenPrice()-InitialStop*Point; k=1; BE=false;}

                  if(Bid-OrderOpenPrice()>=k*StepSize*Point)
                    {
                     BuyStop=OrderStopLoss()+StepSize*Point;
                     if(Bid-BuyStop>=MinDistance*Point)
                       { BuyStop=BuyStop; k=k+1;}
                     else
                        BuyStop=OrderStopLoss();
                    }
                  //Print( " k=",k ," del=", k*StepSize*Point, " BuyStop=", BuyStop," digit=", digit);
                  if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(BuyStop,digit),OrderTakeProfit(),0,LightGreen)==true)
                    {
                     //return(0);

                    }

                 }
              }

           }

// ****************************
// BUY Order TakeProfit via ATR
// ****************************

         if(OrderSelect(cnt,SELECT_BY_POS)==true)
           {
            ATR_TakeProfit=(ATR*OrderTakeProfit());

           }

         if(mode==OP_SELL)
           {
            SellStop=OrderStopLoss();
            if(OrderOpenPrice()-Ask>0 || OrderStopLoss()==0)
              {
               if(OrderOpenPrice()-Ask>=Point*BreakEven && !BE) {SellStop=OrderOpenPrice(); BE=true;}

               if(OrderStopLoss()==0) { SellStop=OrderOpenPrice()+InitialStop*Point; k=1; BE=false;}

               if(OrderOpenPrice()-Ask>=k*StepSize*Point)
                 {
                  SellStop=OrderStopLoss()-StepSize*Point;
                  if(SellStop-Ask>=MinDistance*Point)
                    { SellStop=SellStop; k=k+1;}
                  else
                     SellStop=OrderStopLoss();
                 }
               //Print( " k=",k," del=", k*StepSize*Point, " SellStop=",SellStop," digit=", digit);
               if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(SellStop,digit),OrderTakeProfit(),0,Yellow)==true)
                 {
                  //return(0);
                 }
              }
           }
        }
     }

// *************************
// SELL Order TakeProfit ATR
// *************************

   if(OrderSelect(cnt,SELECT_BY_POS)==true)
     {
      ATR_TakeProfit=(ATR*OrderTakeProfit());
     }
  }


// ---- Scan Trades
int ScanTrades()
  {
   int total=OrdersTotal();
   int numords=0;

   for(int cnt=0; cnt<total; cnt++)
     {

      if(OrderSelect(cnt,SELECT_BY_POS)==true)
        {
         if(OrderSymbol()==Symbol() && OrderType()<=OP_SELL)
            numords++;
        }
     }
   return(numords);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   digit=MarketInfo(Symbol(),MODE_DIGITS);

   if(ScanTrades()<1) return(0);
   else
      if(BreakEven>0 || InitialStop>0 || StepSize>0) StepStops();

   return(0);
  }//int start
//+------------------------------------------------------------------+
